# coding: utf-8
# COMP1730/6730 S1 2023 --- Homework 5
# Submission is due 11:55pm, Saturday the 20th of May, 2023.

# YOUR ANU ID: uxxxxxxx
# YOUR NAME: XXX YYY

# You should implement two function read_map and get_spot; you may define
# more functions if this will help you to achieve the functional
# correctness, and to improve the code quality of you program;
# you should NOT modify test functions (functions with names which start with
# "test_") but you can add more test functions of your own


# import sys
import numpy as np

# DO NOT DELETE THESE STATEMENTS -- THEY ARE USED IN TEST FUNCTIONS
from io import StringIO
from unittest.mock import patch, mock_open
dummy_map_file = 'dummy_map.txt'
the_module = 'map_reader'


def read_map(map_file):
    '''
    should return a nested sequence with 0 or 1 in the inner sequences;
    alternatively, return a 2D numpy array;
    the dimensions (shape in the ndarray case) are to be determined by the
    map_file contents
    THE ABOVE LINES MUST BE REPLACED BY PROPER DOCSTRING
    '''
    with open(map_file) as infile:
        return [[0]], 0.0


def get_spot(world_map, x, y):
    '''
    returns ('land', 'water', 'coast' or 'seashore') depending
    on the location of the point (x, y), latitude and longitude
    '''
    return 'terra-incognita'


# test for mini-world 1
mock_input = ' ' * 5 + '\n' + 3*(' ' + 'x'*3 + ' \n') + ' ' * 5 + '\n'
sample_data = StringIO(mock_input)


@patch(f'{the_module}.open', return_value=sample_data)
def test_read_map(mock_open):
    expected = [[0]*5]
    expected.extend([[0, 1, 1, 1, 0]]*3)
    expected.extend([[0]*5])
    expected = np.asarray(expected, dtype=int)
    # print(expected)
    actual, frac = read_map(dummy_map_file)
    assert abs(frac - 9/25) < 1e-8
    assert mock_open.called
    assert np.array_equal(actual, expected)


# test for mini-world 2
mock_input_2 = '\n'.join([' '*9,
                          '    o    ',
                          '  |   J  ',
                          ' 7     , ',
                          '  ;   o  ',
                          '    _    ',
                          ' '*9])  # + '\n'
sample_data_2 = StringIO(mock_input_2)


@patch(f'{the_module}.open', return_value=sample_data_2)
def test_read_map_2(mock_open):
    expected = [[0]*9]
    expected.append([0, 0, 0, 0, 1, 0, 0, 0, 0])
    expected.append([0, 0, 1, 0, 0, 0, 1, 0, 0])
    expected.append([0, 1, 0, 0, 0, 0, 0, 1, 0])
    expected.append([0, 0, 1, 0, 0, 0, 1, 0, 0])
    expected.append([0, 0, 0, 0, 1, 0, 0, 0, 0])
    expected.append([0]*9)
    expected = np.asarray(expected, dtype=int)
    # print(expected)
    actual, frac = read_map(dummy_map_file)
    assert abs(frac - 8/63) < 1e-8
    assert mock_open.called
    assert np.array_equal(actual, expected)


def test_get_spot():
    # test for mini-world 3
    world = [[0]*5]
    world.extend([[0, 1, 1, 1, 0]]*3)
    world.extend([[0]*5]*2)
    world = np.asarray(world, dtype=int)
    assert get_spot(world, -90, 0) == 'water'  # south pole
    assert get_spot(world, 0, -90) == 'coast'  # equator, pacific
    assert get_spot(world, 0, -120) == 'seashore'  # equator, pacific
    assert get_spot(world, 0, 0) == 'land'    # centre of the world
    # top-left corner of the continent
    assert get_spot(world, 45, -90) == 'coast'
    # ocean shore near top-left corner
    assert get_spot(world, 90, -180) == 'seashore'

    print('All tests passed')
